berhoel/django/media/urls.py
# Django library imports.
from django.urls import path

# Local library imports.
from . import views

__date__ = "2022/07/31 16:47:43 hoel"
__author__ = "Berthold Höllmann"
__copyright__ = "Copyright © 2020 by Berthold Höllmann"
__credits__ = ["Berthold Höllmann"]
__maintainer__ = "Berthold Höllmann"
__email__ = "berhoel@gmail.com"

urlpatterns = [
    path(r"", views.IndexView.as_view(), name="index"),
    path(r"graph/", views.Graph.as_view(), name="graph"),
    path(r"cal/", views.calendar_view, name="calendar"),
    path(r"cal/<int:year>/<int:month>/", views.calendar_view, name="calendar"),
    path(
        "<uuid:pk>/",
        views.SeenUpdateView.as_view(),
        name="view_seen",
    ),
    path(r"add_person/", views.PersonCreateView.as_view()),
    path(
        "<uuid:pk>/edit_person/",
        views.PersonUpdateView.as_view(),
        name="edit_person",
    ),
    path(
        "<uuid:pk>/edit_seen/",
        views.SeenUpdateView.as_view(),
        name="edit_seen",
    ),
    path(
        "delete_seen/<uuid:pk>",
        views.SeenDeleteView.as_view(),
        name="delete_seen",
    ),
]

berhoel/django/media/forms.py
"""Forms for media django project."""

from __future__ import annotations

import logging
from typing import TYPE_CHECKING, Any

from crispy_forms.bootstrap import FormActions
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Fieldset, Layout, Submit
from django import forms
from django.forms.utils import ErrorList

from .models import Person, Seen
from .widgets import BootstrapDatePickerInput

if TYPE_CHECKING:
    from django.core.files.uploadedfile import UploadedFile
    from django.utils.datastructures import MultiValueDict

LOGGER = logging.getLogger(__name__)

__date__ = "2024/08/08 22:55:08 hoel"
__author__ = "Berthold Höllmann"
__copyright__ = "Copyright © 2020 by Berthold Höllmann"
__credits__ = ["Berthold Höllmann"]
__maintainer__ = "Berthold Höllmann"
__email__ = "berhoel@gmail.com"


class PersonForm(forms.ModelForm):
    """Form for person entries."""

    class Meta:
        """Class meta data."""

        model = Person
        fields = ("name",)

    def __init__(  # noqa:PLR0913
        self,
        data: dict[str, Any] | None = None,
        files: MultiValueDict[str, UploadedFile] | None = None,
        auto_id: bool | str = "id_%s",
        prefix: str | None = None,
        initial: dict[str, Any] | None = None,
        error_class: type[ErrorList] = ErrorList,
        label_suffix: str | None = None,
        empty_permitted: bool = False,  # noqa:FBT001,FBT002
        field_order: Any | None = None,  # noqa:ANN401
        use_required_attribute: bool | None = None,
        renderer: Any | None = None,  # noqa:ANN401
    ):
        super().__init__(
            data,
            files,
            auto_id,
            prefix,
            initial,
            error_class,
            label_suffix,
            empty_permitted,
            field_order,
            use_required_attribute,
            renderer,
        )
        self.helper = FormHelper()
        self.helper.form_method = "post"
        self.helper.add_input(Submit("submit", "Save person"))


class SeenForm(forms.ModelForm):
    """Form for seen entries."""

    date = forms.DateField(
        input_formats=["%d/%m/%Y"], widget=BootstrapDatePickerInput()
    )

    class Meta:
        """Class meta data."""

        model = Seen
        fields = ("date", "watch_item")

    def __init__(  # noqa:PLR0913
        self,
        data: dict[str, Any] | None = None,
        files: MultiValueDict[str, UploadedFile] | None = None,
        auto_id: bool | str = "id_%s",
        prefix: str | None = None,
        initial: dict[str, Any] | None = None,
        error_class: type[ErrorList] = ErrorList,
        label_suffix: str | None = None,
        empty_permitted: bool = False,  # noqa:FBT001,FBT002
        field_order: Any | None = None,  # noqa:ANN401
        use_required_attribute: bool | None = None,
        renderer: Any | None = None,  # noqa:ANN401
    ):
        super().__init__(
            data,
            files,
            auto_id,
            prefix,
            initial,
            error_class,
            label_suffix,
            empty_permitted,
            field_order,
            use_required_attribute,
            renderer,
        )
        self.helper = FormHelper()
        self.helper.layout = Layout(
            Fieldset(
                "",
                "date",
                "watch_item",
            ),
            FormActions(
                Submit("update", "Submit Seen", css_class="btn-success"),
                Submit("cancel", "Cancel", css_class="btn-secondary"),
            ),
        )


class SeenDeleteForm(forms.ModelForm):
    """Form for seen delete."""

    date = forms.DateField(
        input_formats=["%d/%m/%Y"], widget=BootstrapDatePickerInput()
    )

    class Meta:
        """Class meta data."""

        model = Seen
        fields = ("date", "watch_item")

    def __init__(  # noqa:PLR0913
        self,
        data: dict[str, Any] | None = None,
        files: MultiValueDict[str, UploadedFile] | None = None,
        auto_id: bool | str = "id_%s",
        prefix: str | None = None,
        initial: dict[str, Any] | None = None,
        error_class: type[ErrorList] = ErrorList,
        label_suffix: str | None = None,
        empty_permitted: bool = False,  # noqa:FBT001,FBT002
        field_order: Any | None = None,  # noqa:ANN401
        use_required_attribute: bool | None = None,
        renderer: Any | None = None,  # noqa:ANN401
    ):
        super().__init__(
            data,
            files,
            auto_id,
            prefix,
            initial,
            error_class,
            label_suffix,
            empty_permitted,
            field_order,
            use_required_attribute,
            renderer,
        )
        self.helper = FormHelper()
        self.helper.layout = Layout(
            Fieldset(
                "",
                "date",
                "watch_item",
            ),
            FormActions(
                Submit("delete", "Delete Seen", css_class="btn-danger"),
                Submit("cancel", "Cancel", css_class="btn-secondary"),
            ),
        )

berhoel/django/media/templates/media/base.html
{# -*- mode:django-html -*- #}
<!-- base.html -->

<!doctype html>

<html lang="en">
  <head>
    {# Required meta tags #}
    <meta charset="utf-8">

    {% load static %}
    {% load fontawesome_5 %}
    {% load bootstrap5 %}

    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <link
      rel="shortcut icon"
      type="image/x-icon"
      href="{% static 'favicon.ico' %}">

    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no">

    {# Bootstrap CSS #}
    {% bootstrap_css %}
    {# FontAwesome_5 CSS #}
    {% fontawesome_5_static %}


    {% block title %} <title>{{ section.title }}</title> {% endblock title %}

  </head>

  <body>
    <div class="{{ section.container }}">
      <h1 class="mt-2"> {{ section.title }} </h1>

      <hr class="mt-0 mb-4"/>
      {% block content %}{% endblock content %}
    </div>

    {% block script %}
    {# Optional JavaScript #}
    {# Bootstrap JS #}
    {% bootstrap_javascript %}
    {% endblock script %}

    {# Display django.contrib.messages as Bootstrap alerts #}
    {% bootstrap_messages %}

    {% block extrascripts %}{% endblock extrascripts %}

  </body>
</html>

<!-- base.html (END) -->

berhoel/django/media/templates/media/datepicker.html
<div
  class="input-append date" id="date" data-date="{% now 'd-m-Y' %}"
  data-date-format="dd-mm-yyyy">
  <label for="id_date">Date:</label>
  <input type="text" name="date" id="id_date" class="input-small">
  <span id="datepicker-icon" class="add-on">
    <i class="icon-calendar"></i>
  </span>
</div>

berhoel/django/media/templates/media/delete_seen.html
{# -*- mode:django-html -*- #}
<!-- delete_seen.html -->
{% spaceless %}
<form method="post" action="">
  <div class="modal-header">
    <h3 class="modal-title">Delete Seen</h3>
    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <p class="delete-text">Are you sure you want to delete seen entry with title
    <strong>
      {% if seen.watch_item.item_type is watch_item_types.SeriesEpisode %}
        {{ seen.watch_item.season.series.title }},
      {% endif %}
      {{ seen.watch_item.title }}{% if seen.watch_item.item_type is watch_item_types.SeriesEpisode %}, s{{ seen.watch_item.season.season }}e{{ seen.watch_item.episode }}{% if watch_item.sub_episode %}.{{ watch_item.sub_episode }}{% endif %}{% endif %}</strong>?</p>
  </div>
  <div class="modal-footer">
    <button type="submit" id="delete-btn" class="btn btn-danger">Delete</button>
  </div>
</form>
{% endspaceless %}
<!-- delete_seen.html (END) -->

berhoel/django/media/templates/media/graph.html
<!-- -*- mode:django-html -*- -->

{% extends './base.html' %}

{% load crispy_forms_tags %}

{% block content %}
{% if graph %}
<div style="width:600;height:500">
  {{ graph|safe }}
</div>
{% endif %}

{% endblock %}

berhoel/django/media/templates/media/index.html
<!-- -*- mode:django-html -*- -->
<!-- index.html -->

{% extends 'media/base.html' %}

{% load crispy_forms_tags %}
{% load fontawesome_5 %}

{% block content %}

{% if seen_list %}
<div class="container-fluid">
  <ul>
    {% for seen in seen_list %}
    <li>{{ seen.date }}:
    <button
  role="button"
  class="bs-modal delete-seen btn btn-sm btn-danger"
  data-bs-toggle="collapse"
  href="#collapse_delete_{{ seen.id }}"
  aria-expanded="false"
  aria-controls="collapse_delete_{{ seen.id }}"
>
  {% fa5_icon 'trash' %}
    </button>
    <a href="{{ seen.watch_item.imdb_url|safe }}" target="_blank" role="button" class="bs-modal btn btn-sm btn-info">
      <img title="Infos on IMDB" src="/static/media/IMDB.png" alt="IMDB" width="15" height="15"></a>
      {% spaceless %}
        {% if seen.watch_item.item_type is watch_item_types.SeriesEpisode %}
          {{ seen.watch_item.season.series.title }},
        {% endif %}
        <a href="{% url 'edit_seen' seen.pk %}">{{ seen.watch_item.title }}</a>
        {% if seen.watch_item.item_type is watch_item_types.SeriesEpisode %}
          , s{{ seen.watch_item.season.season }}e{{ seen.watch_item.episode }}
          {% if watch_item.sub_episode %}.{{ watch_item.sub_episode }}{% endif %}
        {% endif %}
      {% endspaceless %}
      <a href="medium/{{ seen.watch_item.medium.id }}/">({{ seen.media_type }})</a>
    <div class="collapse" id="collapse_delete_{{ seen.id }}">
      <div class="card card-body">
    <form method="POST" action="{% url 'delete_seen' seen.id %}">{% csrf_token %}
      <h3>Delete Seen</h3>
      <p class="delete-text">Are you sure you want to delete seen entry with title
      <strong>
        {% if seen.watch_item.item_type is watch_item_types.SeriesEpisode %}
          {{ seen.watch_item.season.series.title }}, {{ seen.watch_item.title }}
          {% if seen.watch_item.sub_episode %}
            s{{ seen.watch_item.season.season }}e{{ seen.watch_item.episode }}.{{ seen.watch_item.sub_episode }}
          {% else %}
            s{{ seen.watch_item.season.season }}e{{ seen.watch_item.episode }}
          {% endif %}
        {% else %}
          {{ seen.watch_item.title }}
        {% endif %}
      </strong>?</p>
      <button class="submit btn btn-danger">Delete</button>
    </form>
  </div>
</div>
    </li>

    {% endfor %}
  </ul>
  {% else %}
  <p>No seen items.</p>
  {% endif %}
</div>

<div class="pagination">
  <span class="step-links">
    {% if page_obj.has_previous %}
    <a href="?page=1">&laquo; first</a>
    <a href="?page={{ page_obj.previous_page_number }}">previous</a>
    {% endif %}

    <span class="current">
      Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
    </span>

    {% if page_obj.has_next %}
    <a href="?page={{ page_obj.next_page_number }}">next</a>
    <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
    {% endif %}
  </span>
</div>

{% endblock content %}

{% block extrascripts %}
<script type="text/javascript">
  $(function () {

    // Read and Delete seen buttons open modal with id="modal"
    // The formURL is retrieved from the data of the element
    $(".bs-modal").each(function () {
       $(this).modalForm({formURL: $(this).data("form-url")});
    });

    // Hide message
    $(".alert").fadeTo(2000, 500).slideUp(500, function () {
      $(".alert").slideUp(500);
    });

    // delete seen buttons
    $(".delete-seen").each(function () {
      $(this).modalForm({
        modalID: "#modal-crud",
        formURL: $(this).data('id')
      });
    });

    // hide message
    $(".alert").fadeTo(2000, 500).slideUp(500, function(){
      $(".alert").slideUp(500);
    });

    // autofocus to first input field of a modal
    $('.bs-modal').on('shown.bs.modal', function () {
      $('form').find('input[type=text]').filter(':visible:first').focus();
    });
  });
</script>
{% endblock extrascripts %}

<!-- index.html (END) -->

berhoel/django/media/templates/media/person_form.html
<!-- -*- mode:django-html -*- -->

{% extends './base.html' %}

{% load crispy_forms_tags %}

{% block content %}
  <form method="post">
    {% csrf_token %}
    {{ form|crispy }}
    <button type="submit" class="btn btn-success">Save person</button>
  </form>
{% endblock %}

berhoel/django/media/templates/media/person_update_form.html
<!-- -*- mode:django-html -*- -->

<!doctype html>

{% extends './base.html' %}

{% load crispy_forms_tags %}

{% block content %}
  {% crispy form %}
{% endblock %}

berhoel/django/media/templates/media/seen_confirm_delete.html
<!-- -*- mode:django-html -*- -->

<!doctype html>

{% extends './base.html' %}

{% load crispy_forms_tags %}

{% block content %}

{% crispy form %}

{% endblock %}

berhoel/django/media/templates/media/seen_form.html
<!-- -*- mode:django-html -*- -->

<!doctype html>

{% extends './base.html' %}

{% load crispy_forms_tags %}

{% block content %}

{% crispy form %}

{% endblock %}